- Main Page
- Modules
- Data Structures
- Files
- Examples

# uIP application functions
[The uIP TCP/IP stack]

## Detailed Description

Functions used by an application running of top of uIP.

## Defines
#define | uip_outstanding(conn) ((conn)->len)
#define | uip_datalen()
| The length of any incoming data that is currently avaliable (if avaliable) in the uip_appdata buffer.
#define | uip_urgdatalen()
| The length of any out-of-band data (urgent data) that has arrived on the connection.
#define | uip_close()
| Close the current connection.
#define | uip_abort()
| Abort the current connection.
#define | uip_stop()
| Tell the sending host to stop sending data.
#define | uip_stopped(conn)
| Find out if the current connection has been previously stopped with uip_stop().
#define | uip_restart()
| Restart the current connection, if is has previously been stopped with uip_stop().
#define | uip_udpconnection()
| Is the current connection a UDP connection?
#define | uip_newdata()
| Is new incoming data available?
#define | uip_acked()
| Has previously sent data been acknowledged?
#define | uip_connected()
| Has the connection just been connected?
#define | uip_closed()
| Has the connection been closed by the other end?
#define | uip_aborted()
| Has the connection been aborted by the other end?
#define | uip_timedout()
| Has the connection timed out?
#define | uip_rexmit()
| Do we need to retransmit previously data?
#define | uip_poll()
| Is the connection being polled by uIP?
#define | uip_initialmss()
| Get the initial maxium segment size (MSS) of the current connection.
#define | uip_mss()
| Get the current maxium segment size that can be sent on the current connection.
#define | uip_udp_remove(conn)
| Removed a UDP connection.
#define | uip_udp_bind(conn, port)
| Bind a UDP connection to a local port.
#define | uip_udp_send(len)
| Send a UDP datagram of length len on the current connection.
## Functions
void | uip_listen (u16_t port)
| Start listening to the specified port.
void | uip_unlisten (u16_t port)
| Stop listening to the specified port.
uip_conn * | uip_connect (uip_ipaddr_t *ripaddr, u16_t port)
| Connect to a remote host using TCP.
void | uip_send (const void *data, int len)
| Send data on the current connection.
uip_udp_conn * | uip_udp_new (uip_ipaddr_t *ripaddr, u16_t rport)
| Set up a new UDP connection.

## Define Documentation

#define uip_abort | (
|  | ) |

| Abort the current connection. This function will abort (reset) the current connection, and is usually used when an error has occured that prevents using the uip_close() function. Examples: webclient.c. Definition at line 581 of file uip.h. Referenced by httpd_appcall(), and webclient_appcall().

#define uip_aborted | (
|  | ) |

| Has the connection been aborted by the other end? Non-zero if the current connection has been aborted (reset) by the remote host. Examples: smtp.c, telnetd.c, and webclient.c. Definition at line 680 of file uip.h. Referenced by httpd_appcall(), smtp_appcall(), and webclient_appcall().

#define uip_acked | (
|  | ) |

| Has previously sent data been acknowledged? Will reduce to non-zero if the previously sent data has been acknowledged by the remote host. This means that the application can send new data. Examples: telnetd.c, and webclient.c. Definition at line 648 of file uip.h. Referenced by webclient_appcall().

#define uip_close | (
|  | ) |

| Close the current connection. This function will close the current connection in a nice way. Examples: telnetd.c. Definition at line 570 of file uip.h.

#define uip_closed | (
|  | ) |

| Has the connection been closed by the other end? Is non-zero if the connection has been closed by the remote host. The application may then do the necessary clean-ups. Examples: smtp.c, telnetd.c, and webclient.c. Definition at line 670 of file uip.h. Referenced by httpd_appcall(), smtp_appcall(), and webclient_appcall().

#define uip_connected | (
|  | ) |

| Has the connection just been connected? Reduces to non-zero if the current connection has been connected to a remote host. This will happen both if the connection has been actively opened (with uip_connect()) or passively opened (with uip_listen()). Examples: hello-world.c, telnetd.c, and webclient.c. Definition at line 660 of file uip.h. Referenced by hello_world_appcall(), httpd_appcall(), and webclient_appcall().

#define uip_datalen | (
|  | ) |

| The length of any incoming data that is currently avaliable (if avaliable) in the uip_appdata buffer. The test function uip_data() must first be used to check if there is any data available at all. Examples: dhcpc.c, telnetd.c, and webclient.c. Definition at line 550 of file uip.h.

#define uip_mss | (
|  | ) |

| Get the current maxium segment size that can be sent on the current connection. The current maxiumum segment size that can be sent on the connection is computed from the receiver's window and the MSS of the connection (which also is available by calling uip_initialmss()). Examples: telnetd.c, and webclient.c. Definition at line 737 of file uip.h.

#define uip_newdata | (
|  | ) |

| Is new incoming data available? Will reduce to non-zero if there is new data for the application present at the uip_appdata pointer. The size of the data is avaliable through the uip_len variable. Examples: dhcpc.c, resolv.c, telnetd.c, and webclient.c. Definition at line 637 of file uip.h. Referenced by psock_newdata(), resolv_appcall(), and webclient_appcall().

#define uip_poll | (
|  | ) |

| Is the connection being polled by uIP? Is non-zero if the reason the application is invoked is that the current connection has been idle for a while and should be polled. The polling event can be used for sending data without having to wait for the remote host to send data. Examples: resolv.c, telnetd.c, and webclient.c. Definition at line 716 of file uip.h. Referenced by httpd_appcall(), resolv_appcall(), and webclient_appcall().

#define uip_restart | (
|  | ) |

| Restart the current connection, if is has previously been stopped with uip_stop(). This function will open the receiver's window again so that we start receiving data for the current connection. Definition at line 610 of file uip.h.

#define uip_rexmit | (
|  | ) |

| Do we need to retransmit previously data? Reduces to non-zero if the previously sent data has been lost in the network, and the application should retransmit it. The application should send the exact same data as it did the last time, using the uip_send() function. Examples: telnetd.c, and webclient.c. Definition at line 702 of file uip.h. Referenced by webclient_appcall().

#define uip_stop | (
|  | ) |

| Tell the sending host to stop sending data. This function will close our receiver's window so that we stop receiving data for the current connection. Definition at line 591 of file uip.h.

#define uip_timedout | (
|  | ) |

| Has the connection timed out? Non-zero if the current connection has been aborted due to too many retransmissions. Examples: smtp.c, telnetd.c, and webclient.c. Definition at line 690 of file uip.h. Referenced by httpd_appcall(), smtp_appcall(), and webclient_appcall().

#define uip_udp_bind | ( | conn,
|  | port |  | ) |

  | Bind a UDP connection to a local port. Parameters:
  | conn | A pointer to the uip_udp_conn structure for the connection.
  | port | The local port number, in network byte order.
Examples: dhcpc.c. Definition at line 787 of file uip.h.

#define uip_udp_remove | ( | conn |  | ) |

  | Removed a UDP connection. Parameters:
  | conn | A pointer to the uip_udp_conn structure for the connection.
Examples: resolv.c. Definition at line 775 of file uip.h. Referenced by resolv_conf().

#define uip_udp_send | ( | len |  | ) |

  | Send a UDP datagram of length len on the current connection. This function can only be called in response to a UDP event (poll or newdata). The data must be present in the uip_buf buffer, at the place pointed to by the uip_appdata pointer. Parameters:
  | len | The length of the data in the uip_buf buffer.
Examples: resolv.c. Definition at line 800 of file uip.h.

#define uip_udpconnection | (
|  | ) |

| Is the current connection a UDP connection? This function checks whether the current connection is a UDP connection. Definition at line 626 of file uip.h.

#define uip_urgdatalen | (
|  | ) |

| The length of any out-of-band data (urgent data) that has arrived on the connection. Note: The configuration parameter UIP_URGDATA must be set for this function to be enabled. Definition at line 561 of file uip.h.

## Function Documentation

struct uip_conn* uip_connect | ( | uip_ipaddr_t * | ripaddr,
|  | u16_t | port
| ) |

| Connect to a remote host using TCP. This function is used to start a new connection to the specified port on the specied host. It allocates a new connection identifier, sets the connection to the SYN_SENT state and sets the retransmission timer to 0. This will cause a TCP SYN segment to be sent out the next time this connection is periodically processed, which usually is done within 0.5 seconds after the call to uip_connect(). Note: This function is avaliable only if support for active open has been configured by defining UIP_ACTIVE_OPEN to 1 in uipopt.h. Since this function requires the port number to be in network byte order, a conversion using HTONS() or htons() is necessary.
     uip_ipaddr_t ipaddr;

     uip_ipaddr(&ipaddr, 192,168,1,2);
     uip_connect(&ipaddr, HTONS(80));
  Parameters:
  | ripaddr | The IP address of the remote hot.
  | port | A 16-bit port number in network byte order.
Returns: A pointer to the uIP connection identifier for the new connection, or NULL if no connection could be allocated. Examples: smtp.c, and webclient.c. Definition at line 407 of file uip.c. References htons(), uip_conn::lport, uip_conn::tcpstateflags, UIP_CLOSED, uip_conn, UIP_CONNS, and uip_conns. Referenced by smtp_send(), and webclient_get().

void uip_listen | ( | u16_t | port | ) |

| Start listening to the specified port. Note: Since this function expects the port number in network byte order, a conversion using HTONS() or htons() is necessary.
     uip_listen(HTONS(80));
  Parameters:
  | port | A 16-bit port number in network byte order.
Examples: hello-world.c, and telnetd.c. Definition at line 529 of file uip.c. References UIP_LISTENPORTS. Referenced by hello_world_init(), and httpd_init().

void uip_send | ( | const void * | data,
|  | int | len
| ) |

  | Send data on the current connection. This function is used to send out a single segment of TCP data. Only applications that have been invoked by uIP for event processing can send data. The amount of data that actually is sent out after a call to this funcion is determined by the maximum amount of data TCP allows. uIP will automatically crop the data so that only the appropriate amount of data is sent. The function uip_mss() can be used to query uIP for the amount of data that actually will be sent. Note: This function does not guarantee that the sent data will arrive at the destination. If the data is lost in the network, the application will be invoked with the uip_rexmit() event being set. The application will then have to resend the data using this function. Parameters:
  | data | A pointer to the data which is to be sent.
  | len | The maximum amount of data bytes to be sent.
Examples: dhcpc.c, telnetd.c, and webclient.c. Definition at line 1888 of file uip.c. References uip_sappdata, and uip_slen.

struct uip_udp_conn* uip_udp_new | ( | uip_ipaddr_t * | ripaddr,
|  | u16_t | rport
| ) |

| Set up a new UDP connection. This function sets up a new UDP connection. The function will automatically allocate an unused local port for the new connection. However, another port can be chosen by using the uip_udp_bind() call, after the uip_udp_new() function has been called. Example:
     uip_ipaddr_t addr;
     struct uip_udp_conn *c;

     uip_ipaddr(&addr, 192,168,2,1);
     c = uip_udp_new(&addr, HTONS(12345));
     if(c != NULL) {
       uip_udp_bind(c, HTONS(12344));
     }
  Parameters:
  | ripaddr | The IP address of the remote host.
  | rport | The remote port number in network byte order.
Returns: The uip_udp_conn structure for the new connection or NULL if no connection could be allocated. Examples: dhcpc.c, and resolv.c. Definition at line 473 of file uip.c. References htons(), uip_udp_conn::lport, uip_udp_conn, UIP_UDP_CONNS, and uip_udp_conns. Referenced by resolv_conf().

void uip_unlisten | ( | u16_t | port | ) |

| Stop listening to the specified port. Note: Since this function expects the port number in network byte order, a conversion using HTONS() or htons() is necessary.
     uip_unlisten(HTONS(80));
  Parameters:
  | port | A 16-bit port number in network byte order.
Definition at line 518 of file uip.c. References UIP_LISTENPORTS.